﻿Option Strict On
Imports Microsoft.Devices.Sensors
Partial Public Class MainPage
    Inherits PhoneApplicationPage

    ' コンストラクター
    Public Sub New()
        InitializeComponent()
    End Sub

    Dim myAccelerometer As New Accelerometer
    Private Sub MainPage_Loaded(sender As Object, e As System.Windows.RoutedEventArgs) Handles MyBase.Loaded
        AddHandler myAccelerometer.CurrentValueChanged, Sub(senderValue As Object, eValue As SensorReadingEventArgs(Of AccelerometerReading))
                                                            Deployment.Current.Dispatcher.BeginInvoke(Sub() CurrentValueChanged(eValue.SensorReading))
                                                        End Sub
        myAccelerometer.Start()
    End Sub

    Private Sub CurrentValueChanged(myReading As AccelerometerReading)
        Dim myAcceleration = myReading.Acceleration

        If myAcceleration.Y > 1 Then
            myAcceleration.Y = 1
        ElseIf myAcceleration.Y < -1 Then
            myAcceleration.Y = -1
        End If

        myPlainProjection.RotationZ = Math.Asin(Math.Abs(myAcceleration.Y)) * 180 / Math.PI

        TextBlock1.Text = CStr(Math.Round(myPlainProjection.RotationZ)) & "°傾いています。"

    End Sub

    Private Sub MainPage_Unloaded(sender As Object, e As System.Windows.RoutedEventArgs) Handles MyBase.Unloaded
        myAccelerometer.Stop()
        myAccelerometer = Nothing
    End Sub
End Class
